Index: pjproject/trunk/pjsip-apps/src/py_pjsua/py_pjsua.c
===================================================================
--- pjproject/trunk/pjsip-apps/src/py_pjsua/py_pjsua.c	(revision 850)
+++ pjproject/trunk/pjsip-apps/src/py_pjsua/py_pjsua.c	(revision 851)
@@ -4093,55 +4452,383 @@
     0,                              /*tp_as_buffer*/
     Py_TPFLAGS_DEFAULT,             /*tp_flags*/
-    "Acc ID objects",         /*tp_doc*/
-    0,                              /*tp_traverse*/
-    0,                              /*tp_clear*/
-    0,                              /*tp_richcompare*/
+    "Buddy Config objects",       /* tp_doc */
+    0,                              /* tp_traverse */
+    0,                              /* tp_clear */
+    0,                              /* tp_richcompare */
     0,                              /* tp_weaklistoffset */
     0,                              /* tp_iter */
     0,                              /* tp_iternext */
     0,                              /* tp_methods */
-    acc_id_members,           /* tp_members */
+    buddy_config_members,         /* tp_members */
+    0,                              /* tp_getset */
+    0,                              /* tp_base */
+    0,                              /* tp_dict */
+    0,                              /* tp_descr_get */
+    0,                              /* tp_descr_set */
+    0,                              /* tp_dictoffset */
+    0,                              /* tp_init */
+    0,                              /* tp_alloc */
+    buddy_config_new,             /* tp_new */
 
 };
 
 /*
- * py_pjsua_acc_config_default
- */
-static PyObject *py_pjsua_acc_config_default
+ * buddy_info_Object
+ * Buddy Info
+ * !modified @ 071206
+ */
+typedef struct
+{
+    PyObject_HEAD
+    /* Type-specific fields go here. */ 
+    int id;
+    PyObject * uri;
+    PyObject * contact;
+    int status;
+    PyObject * status_text;
+    int monitor_pres;
+    char buf_[256];
+} buddy_info_Object;
+
+
+/*
+ * buddy_info_dealloc
+ * deletes a buddy_info from memory
+ * !modified @ 071206
+ */
+static void buddy_info_dealloc(buddy_info_Object* self)
+{
+    Py_XDECREF(self->uri);
+    Py_XDECREF(self->contact);
+    Py_XDECREF(self->status_text);
+    
+    self->ob_type->tp_free((PyObject*)self);
+}
+
+
+/*
+ * buddy_info_new
+ * constructor for buddy_info object
+ * !modified @ 071206
+ */
+static PyObject * buddy_info_new(PyTypeObject *type, PyObject *args,
+                                    PyObject *kwds)
+{
+    buddy_info_Object *self;
+
+    self = (buddy_info_Object *)type->tp_alloc(type, 0);
+    if (self != NULL)
+    {
+        self->uri = PyString_FromString("");
+        if (self->uri == NULL)
+    	{
+            Py_DECREF(self);
+            return NULL;
+        }        
+	self->contact = PyString_FromString("");
+        if (self->contact == NULL)
+    	{
+            Py_DECREF(self);
+            return NULL;
+        }
+	self->status_text = PyString_FromString("");
+        if (self->status_text == NULL)
+    	{
+            Py_DECREF(self);
+            return NULL;
+        }
+	
+    }
+    return (PyObject *)self;
+}
+
+/*
+ * buddy_info_members
+ * !modified @ 071206
+ */
+static PyMemberDef buddy_info_members[] =
+{
+    {
+        "id", T_INT, 
+        offsetof(buddy_info_Object, id), 0,
+        "The buddy ID."
+    },
+    {
+        "uri", T_OBJECT_EX,
+        offsetof(buddy_info_Object, uri), 0,
+        "The full URI of the buddy, as specified in the configuration. "        
+    },
+    {
+        "contact", T_OBJECT_EX,
+        offsetof(buddy_info_Object, contact), 0,
+        "Buddy's Contact, only available when presence subscription "
+        "has been established to the buddy."        
+    },
+    {
+        "status", T_INT, 
+        offsetof(buddy_info_Object, status), 0,
+        "Buddy's online status. "
+    },
+    {
+        "status_text", T_OBJECT_EX,
+        offsetof(buddy_info_Object, status_text), 0,
+        "Text to describe buddy's online status."        
+    },
+    {
+        "monitor_pres", T_INT, 
+        offsetof(buddy_info_Object, monitor_pres), 0,
+        "Flag to indicate that we should monitor the presence information "
+        "for this buddy (normally yes, unless explicitly disabled). "
+    },
+    
+    
+    {NULL}  /* Sentinel */
+};
+
+
+
+
+/*
+ * buddy_info_Type
+ */
+static PyTypeObject buddy_info_Type =
+{
+    PyObject_HEAD_INIT(NULL)
+    0,                              /*ob_size*/
+    "py_pjsua.Buddy_Info",      /*tp_name*/
+    sizeof(buddy_info_Object),  /*tp_basicsize*/
+    0,                              /*tp_itemsize*/
+    (destructor)buddy_info_dealloc,/*tp_dealloc*/
+    0,                              /*tp_print*/
+    0,                              /*tp_getattr*/
+    0,                              /*tp_setattr*/
+    0,                              /*tp_compare*/
+    0,                              /*tp_repr*/
+    0,                              /*tp_as_number*/
+    0,                              /*tp_as_sequence*/
+    0,                              /*tp_as_mapping*/
+    0,                              /*tp_hash */
+    0,                              /*tp_call*/
+    0,                              /*tp_str*/
+    0,                              /*tp_getattro*/
+    0,                              /*tp_setattro*/
+    0,                              /*tp_as_buffer*/
+    Py_TPFLAGS_DEFAULT,             /*tp_flags*/
+    "Buddy Info objects",       /* tp_doc */
+    0,                              /* tp_traverse */
+    0,                              /* tp_clear */
+    0,                              /* tp_richcompare */
+    0,                              /* tp_weaklistoffset */
+    0,                              /* tp_iter */
+    0,                              /* tp_iternext */
+    0,                              /* tp_methods */
+    buddy_info_members,         /* tp_members */
+    0,                              /* tp_getset */
+    0,                              /* tp_base */
+    0,                              /* tp_dict */
+    0,                              /* tp_descr_get */
+    0,                              /* tp_descr_set */
+    0,                              /* tp_dictoffset */
+    0,                              /* tp_init */
+    0,                              /* tp_alloc */
+    buddy_info_new,             /* tp_new */
+
+};
+
+/*
+ * py_pjsua_get_buddy_count
+ */
+static PyObject *py_pjsua_get_buddy_count
 (PyObject *pSelf, PyObject *pArgs)
-{
-    acc_config_Object *obj;
-    pjsua_acc_config cfg;
-	int i;
-
-    if (!PyArg_ParseTuple(pArgs, "O", &obj))
-    {
-        return NULL;
-    }
-    pjsua_acc_config_default(&cfg);
-	obj->cred_count = cfg.cred_count;
-	for (i = 0; i < 8; i++) 
-	{
-		obj->cred_info[i] = cfg.cred_info[i];
+{    
+    int ret;
+
+    if (!PyArg_ParseTuple(pArgs, ""))
+    {
+        return NULL;
+    }
+    ret = pjsua_get_buddy_count();
+	
+    return Py_BuildValue("i", ret);
+}
+
+/*
+ * py_pjsua_buddy_is_valid
+ */
+static PyObject *py_pjsua_buddy_is_valid
+(PyObject *pSelf, PyObject *pArgs)
+{    
+    int id;
+    int is_valid;
+
+    if (!PyArg_ParseTuple(pArgs, "i", &id))
+    {
+        return NULL;
+    }
+    is_valid = pjsua_buddy_is_valid(id);
+	
+    return Py_BuildValue("i", is_valid);
+}
+
+/*
+ * py_pjsua_enum_buddies
+ * !modified @ 061206
+ */
+static PyObject *py_pjsua_enum_buddies(PyObject *pSelf, PyObject *pArgs)
+{
+    pj_status_t status;
+    PyObject *list;
+    
+    pjsua_buddy_id *id;
+    int c, i;
+    if (!PyArg_ParseTuple(pArgs, "i", &c))
+    {
+        return NULL;
+    }	
+    
+    id = (pjsua_buddy_id *)malloc(c * sizeof(pjsua_buddy_id));
+    status = pjsua_enum_buddies(id, &c);
+    
+    list = PyList_New(c);
+    for (i = 0; i < c; i++) {
+        int ret = PyList_SetItem(list, i, Py_BuildValue("i", id[i]));
+        if (ret == -1) {
+            return NULL;
 	}
-	Py_XDECREF(obj->force_contact);
-	obj->force_contact = 
-		PyString_FromStringAndSize(cfg.force_contact.ptr, 
-		cfg.force_contact.slen);
-	obj->priority = cfg.priority;
-	Py_XDECREF(obj->id);
-	obj->id = 
-		PyString_FromStringAndSize(cfg.id.ptr, cfg.id.slen);
-	Py_XDECREF(obj->reg_uri);
-	obj->reg_uri = 
-		PyString_FromStringAndSize(cfg.reg_uri.ptr, cfg.reg_uri.slen);
-	obj->proxy_cnt = cfg.proxy_cnt;
-	for (i = 0; i < 8; i++) 
-	{
-		obj->proxy[i] = cfg.proxy[i];
+    }
+    
+    free(id);
+    return Py_BuildValue("O",list);
+}
+
+/*
+ * py_pjsua_buddy_get_info
+ * !modified @ 071206
+ */
+static PyObject *py_pjsua_buddy_get_info
+(PyObject *pSelf, PyObject *pArgs)
+{    	
+    int buddy_id;
+    buddy_info_Object * obj;
+    pjsua_buddy_info info;
+    int status;	
+    int i;
+
+    if (!PyArg_ParseTuple(pArgs, "i", &buddy_id))
+    {
+        return NULL;
+    }
+	
+    
+    status = pjsua_buddy_get_info(buddy_id, &info);
+    if (status == PJ_SUCCESS) {
+	obj = (buddy_info_Object *)buddy_info_new(&buddy_info_Type,NULL,NULL);
+        obj->id = info.id;
+        Py_XDECREF(obj->uri);
+        obj->uri =
+            PyString_FromStringAndSize(info.uri.ptr, 
+            info.uri.slen);
+        Py_XDECREF(obj->contact);
+        obj->contact =
+            PyString_FromStringAndSize(info.contact.ptr, 
+            info.contact.slen);
+        obj->status = info.status;
+        Py_XDECREF(obj->status_text);
+        obj->status_text =
+            PyString_FromStringAndSize(info.status_text.ptr, 
+            info.status_text.slen);
+        obj->monitor_pres = info.monitor_pres;
+        for (i = 0; i < 256; i++) {
+	    
+            obj->buf_[i] = info.buf_[i];
 	}
-	obj->publish_enabled = cfg.publish_enabled;
-	obj->reg_timeout = cfg.reg_timeout;
 	
+        return Py_BuildValue("O", obj);
+    } else {
+	Py_INCREF(Py_None);
+	return Py_None;
+    }
+}
+
+/*
+ * py_pjsua_buddy_add
+ * !modified @ 061206
+ */
+static PyObject *py_pjsua_buddy_add
+(PyObject *pSelf, PyObject *pArgs)
+{        
+    buddy_config_Object * bc;
+    pjsua_buddy_config cfg;
+    
+    int p_buddy_id;
+    int status;
+
+    if (!PyArg_ParseTuple(pArgs, "O", &bc))
+    {
+        return NULL;
+    }
+    cfg.subscribe = bc->subscribe;
+    cfg.uri.ptr = PyString_AsString(bc->uri);
+    cfg.uri.slen = strlen(PyString_AsString(bc->uri));    
+    
+    status = pjsua_buddy_add(&cfg, &p_buddy_id);
+    
+    return Py_BuildValue("ii", status, p_buddy_id);
+}
+
+/*
+ * py_pjsua_buddy_del
+ */
+static PyObject *py_pjsua_buddy_del
+(PyObject *pSelf, PyObject *pArgs)
+{    
+    int buddy_id;
+    int status;
+
+    if (!PyArg_ParseTuple(pArgs, "i", &buddy_id))
+    {
+        return NULL;
+    }
+	
+	
+    status = pjsua_buddy_del(buddy_id);	
+    return Py_BuildValue("i", status);
+}
+
+/*
+ * py_pjsua_buddy_subscribe_pres
+ */
+static PyObject *py_pjsua_buddy_subscribe_pres
+(PyObject *pSelf, PyObject *pArgs)
+{    
+    int buddy_id;
+    int status;
+    int subscribe;
+
+    if (!PyArg_ParseTuple(pArgs, "ii", &buddy_id, &subscribe))
+    {
+        return NULL;
+    }
+	
+	
+    status = pjsua_buddy_subscribe_pres(buddy_id, subscribe);	
+    return Py_BuildValue("i", status);
+}
+
+/*
+ * py_pjsua_pres_dump
+ */
+static PyObject *py_pjsua_pres_dump
+(PyObject *pSelf, PyObject *pArgs)
+{    
+    int verbose;
+
+    if (!PyArg_ParseTuple(pArgs, "i", &verbose))
+    {
+        return NULL;
+    }
+	
+	
+    pjsua_pres_dump(verbose);	
     Py_INCREF(Py_None);
     return Py_None;
@@ -4149,536 +4836,114 @@
 
 /*
- * py_pjsua_acc_get_count
- */
-static PyObject *py_pjsua_acc_get_count
-(PyObject *pSelf, PyObject *pArgs)
-{
-	int count;
-    if (!PyArg_ParseTuple(pArgs, ""))
-    {
-        return NULL;
-    }
-    count = pjsua_acc_get_count();
-    return Py_BuildValue("i",count);
-}
-
-/*
- * py_pjsua_acc_is_valid
- */
-static PyObject *py_pjsua_acc_is_valid
+ * py_pjsua_im_send
+ * !modified @ 071206
+ */
+static PyObject *py_pjsua_im_send
 (PyObject *pSelf, PyObject *pArgs)
 {    
-	int id;
-	int is_valid;
-
-    if (!PyArg_ParseTuple(pArgs, "i", &id))
-    {
-        return NULL;
-    }
-    is_valid = pjsua_acc_is_valid(id);
+    int status;
+    int acc_id;
+    pj_str_t to, mime_type, content;
+    PyObject * st;
+    PyObject * smt;
+    PyObject * sc;
+    pjsua_msg_data msg_data;
+    msg_data_Object * omd;
+    int user_data;
+    pj_pool_t *pool;
+
+    if (!PyArg_ParseTuple(pArgs, "iOOOOi", &acc_id, &st, &smt, &sc, &omd, &user_data))
+    {
+        return NULL;
+    }
 	
-    return Py_BuildValue("i", is_valid);
-}
-
-/*
- * py_pjsua_acc_set_default
- */
-static PyObject *py_pjsua_acc_set_default
+    to.ptr = PyString_AsString(st);
+    to.slen = strlen(PyString_AsString(st));
+    mime_type.ptr = PyString_AsString(smt);
+    mime_type.slen = strlen(PyString_AsString(smt));
+    content.ptr = PyString_AsString(sc);
+    content.slen = strlen(PyString_AsString(sc));
+    msg_data.content_type.ptr = PyString_AsString(omd->content_type);
+    msg_data.content_type.slen = strlen(PyString_AsString(omd->content_type));
+    msg_data.msg_body.ptr = PyString_AsString(omd->msg_body);
+    msg_data.msg_body.slen = strlen(PyString_AsString(omd->msg_body));
+    pool = pjsua_pool_create("pjsua", 4000, 4000);
+
+    translate_hdr(pool, &msg_data.hdr_list, omd->hdr_list);
+    status = pjsua_im_send(acc_id, &to, &mime_type, &content, &msg_data, &user_data);	
+    pj_pool_release(pool);
+    return Py_BuildValue("i",status);
+}
+
+/*
+ * py_pjsua_im_typing
+ */
+static PyObject *py_pjsua_im_typing
 (PyObject *pSelf, PyObject *pArgs)
 {    
-	int id;
-	int status;
-
-    if (!PyArg_ParseTuple(pArgs, "i", &id))
-    {
-        return NULL;
-    }
-    status = pjsua_acc_set_default(id);
+    int status;
+    int acc_id;
+    pj_str_t to;
+    PyObject * st;
+    int is_typing;
+    pjsua_msg_data msg_data;
+    msg_data_Object * omd;
+    pj_pool_t * pool;
+
+    if (!PyArg_ParseTuple(pArgs, "iOiO", &acc_id, &st, &is_typing, &omd))
+    {
+        return NULL;
+    }
 	
-    return Py_BuildValue("i", status);
-}
-
-/*
- * py_pjsua_acc_get_default
- */
-static PyObject *py_pjsua_acc_get_default
-(PyObject *pSelf, PyObject *pArgs)
-{    
-	int id;
-	
-    if (!PyArg_ParseTuple(pArgs, ""))
-    {
-        return NULL;
-    }
-    id = pjsua_acc_get_default();
-	
-    return Py_BuildValue("i", id);
-}
-
-/*
- * py_pjsua_acc_add
- */
-static PyObject *py_pjsua_acc_add
-(PyObject *pSelf, PyObject *pArgs)
-{    
-	int is_default;
-	acc_config_Object * ac;
-	pjsua_acc_config cfg;
-	acc_id_Object * id;
-	int p_acc_id;
-	int status;
-	int i;
-
-    if (!PyArg_ParseTuple(pArgs, "OiO", &ac, &is_default, &id))
-    {
-        return NULL;
-    }
-	cfg.cred_count = ac->cred_count;
-	for (i = 0; i < 8; i++) 
-	{
-		cfg.cred_info[i] = ac->cred_info[i];
-	}
-	cfg.force_contact.ptr = PyString_AsString(ac->force_contact);
-	cfg.force_contact.slen = strlen(PyString_AsString(ac->force_contact));
-	cfg.id.ptr = PyString_AsString(ac->id);
-	cfg.id.slen = strlen(PyString_AsString(ac->id));
-	cfg.priority = ac->priority;
-	for (i = 0; i < 8; i++) {
-		cfg.proxy[i] = ac->proxy[i];
-	}
-	cfg.proxy_cnt = ac->proxy_cnt;
-	cfg.publish_enabled = ac->publish_enabled;
-	cfg.reg_timeout = ac->reg_timeout;
-	cfg.reg_uri.ptr = PyString_AsString(ac->reg_uri);
-	cfg.reg_uri.slen = strlen(PyString_AsString(ac->reg_uri));
-	p_acc_id = id->acc_id;
-    status = pjsua_acc_add(&cfg, is_default, &p_acc_id);
-	id->acc_id = p_acc_id;
-    return Py_BuildValue("i", status);
-}
-
-/*
- * py_pjsua_acc_add_local
- */
-static PyObject *py_pjsua_acc_add_local
-(PyObject *pSelf, PyObject *pArgs)
-{    
-	int is_default;
-	int tid;
-	acc_id_Object * id;
-	int p_acc_id;
-	int status;
-	
-
-    if (!PyArg_ParseTuple(pArgs, "iiO", &tid, &is_default, &id))
-    {
-        return NULL;
-    }
-	
-	p_acc_id = id->acc_id;
-    status = pjsua_acc_add_local(tid, is_default, &p_acc_id);
-	id->acc_id = p_acc_id;
-    return Py_BuildValue("i", status);
-}
-
-/*
- * py_pjsua_acc_del
- */
-static PyObject *py_pjsua_acc_del
-(PyObject *pSelf, PyObject *pArgs)
-{    
-	int acc_id;
-	int status;
-	
-    if (!PyArg_ParseTuple(pArgs, "i", &acc_id))
-    {
-        return NULL;
-    }
-	
-	
-    status = pjsua_acc_del(acc_id);	
-    return Py_BuildValue("i", status);
-}
-
-/*
- * py_pjsua_acc_modify
- */
-static PyObject *py_pjsua_acc_modify
-(PyObject *pSelf, PyObject *pArgs)
-{    	
-	acc_config_Object * ac;
-	pjsua_acc_config cfg;	
-	int acc_id;
-	int status;
-	int i;
-
-    if (!PyArg_ParseTuple(pArgs, "iO", &acc_id, &ac))
-    {
-        return NULL;
-    }
-	cfg.cred_count = ac->cred_count;
-	for (i = 0; i < 8; i++) 
-	{
-		cfg.cred_info[i] = ac->cred_info[i];
-	}
-	cfg.force_contact.ptr = PyString_AsString(ac->force_contact);
-	cfg.force_contact.slen = strlen(PyString_AsString(ac->force_contact));
-	cfg.id.ptr = PyString_AsString(ac->id);
-	cfg.id.slen = strlen(PyString_AsString(ac->id));
-	cfg.priority = ac->priority;
-	for (i = 0; i < 8; i++) {
-		cfg.proxy[i] = ac->proxy[i];
-	}
-	cfg.proxy_cnt = ac->proxy_cnt;
-	cfg.publish_enabled = ac->publish_enabled;
-	cfg.reg_timeout = ac->reg_timeout;
-	cfg.reg_uri.ptr = PyString_AsString(ac->reg_uri);
-	cfg.reg_uri.slen = strlen(PyString_AsString(ac->reg_uri));	
-    status = pjsua_acc_modify(acc_id, &cfg);	
-    return Py_BuildValue("i", status);
-}
-
-/*
- * py_pjsua_acc_set_online_status
- */
-static PyObject *py_pjsua_acc_set_online_status
-(PyObject *pSelf, PyObject *pArgs)
-{    
-	int is_online;	
-	int acc_id;
-	int status;	
-
-    if (!PyArg_ParseTuple(pArgs, "ii", &acc_id, &is_online))
-    {
-        return NULL;
-    }
-	
-    status = pjsua_acc_set_online_status(acc_id, is_online);
-	
-    return Py_BuildValue("i", status);
-}
-
-/*
- * py_pjsua_acc_set_registration
- */
-static PyObject *py_pjsua_acc_set_registration
-(PyObject *pSelf, PyObject *pArgs)
-{    
-	int renew;	
-	int acc_id;
-	int status;	
-
-    if (!PyArg_ParseTuple(pArgs, "ii", &acc_id, &renew))
-    {
-        return NULL;
-    }
-	
-    status = pjsua_acc_set_registration(acc_id, renew);
-	
-    return Py_BuildValue("i", status);
-}
-
-/*
- * py_pjsua_acc_set_get_info
- */
-static PyObject *py_pjsua_acc_get_info
-(PyObject *pSelf, PyObject *pArgs)
-{    	
-	int acc_id;
-	acc_info_Object * obj;
-	pjsua_acc_info info;
-	int status;	
-	int i;
-
-    if (!PyArg_ParseTuple(pArgs, "iO", &acc_id, &obj))
-    {
-        return NULL;
-    }
-	
-	info.acc_uri.ptr = PyString_AsString(obj->acc_uri);
-	info.acc_uri.slen = strlen(PyString_AsString(obj->acc_uri));
-	for (i = 0; i < PJ_ERR_MSG_SIZE; i++) {
-		info.buf_[i] = obj->buf_[i];
-	}
-	info.expires = obj->expires;
-	info.has_registration = obj->has_registration;
-	info.id = obj->id;
-	info.is_default = obj->is_default;
-	info.online_status = obj->online_status;
-	info.status = obj->status;
-	info.status_text.ptr = PyString_AsString(obj->status_text);
-	info.status_text.slen = strlen(PyString_AsString(obj->status_text));
-    status = pjsua_acc_get_info(acc_id, &info);
-	obj->acc_uri =
-		PyString_FromStringAndSize(info.acc_uri.ptr, 
-		info.acc_uri.slen);
-	for (i = 0; i < PJ_ERR_MSG_SIZE; i++) {
-		obj->buf_[i] = info.buf_[i];
-	}
-	obj->expires = info.expires;
-	obj->has_registration = info.has_registration;
-	obj->id = info.id;
-	obj->is_default = info.is_default;
-	obj->online_status = info.online_status;
-	obj->status = info.status;
-	obj->status_text =
-		PyString_FromStringAndSize(info.status_text.ptr, 
-		info.status_text.slen);
-    return Py_BuildValue("i", status);
-}
-
-/*
- * py_pjsua_enum_accs
- */
-static PyObject *py_pjsua_enum_accs(PyObject *pSelf, PyObject *pArgs)
-{
-    pj_status_t status;
-	PyObject *list;
-	integer_Object *count;
-	pjsua_acc_id *id;
-	int c, i;
-    if (!PyArg_ParseTuple(pArgs, "OO", &list, &count))
-    {
-        return NULL;
-    }	
-	c = count->integer;
-	id = (pjsua_acc_id *)malloc(c * sizeof(pjsua_acc_id));
-    status = pjsua_enum_accs(id, &c);
-	Py_XDECREF(list);
-	list = PyList_New(c);
-	for (i = 0; i < c; i++) {
-		int ret = PyList_SetItem(list, i, Py_BuildValue("i", id[i]));
-		if (ret == -1) {
-			return NULL;
-		}
-	}
-	count->integer = c;
-	free(id);
+    to.ptr = PyString_AsString(st);
+    to.slen = strlen(PyString_AsString(st));    
+    msg_data.content_type.ptr = PyString_AsString(omd->content_type);
+    msg_data.content_type.slen = strlen(PyString_AsString(omd->content_type));
+    msg_data.msg_body.ptr = PyString_AsString(omd->msg_body);
+    msg_data.msg_body.slen = strlen(PyString_AsString(omd->msg_body));
+    pool = pjsua_pool_create("pjsua", 4000, 4000);
+
+    translate_hdr(pool, &msg_data.hdr_list, omd->hdr_list);
+    status = pjsua_im_typing(acc_id, &to, is_typing, &msg_data);	
+    pj_pool_release(pool);
     return Py_BuildValue("i",status);
 }
 
-/*
- * py_pjsua_acc_enum_info
- */
-static PyObject *py_pjsua_acc_enum_info(PyObject *pSelf, PyObject *pArgs)
-{
-    pj_status_t status;
-	PyObject *list;
-	integer_Object *count;
-	pjsua_acc_info *info;
-	int c, i;
-    if (!PyArg_ParseTuple(pArgs, "OO", &list, &count))
-    {
-        return NULL;
-    }	
-	c = count->integer;
-	info = (pjsua_acc_info *)malloc(c * sizeof(pjsua_acc_info));
-    status = pjsua_acc_enum_info(info, &c);
-	Py_XDECREF(list);
-	list = PyList_New(c);
-	for (i = 0; i < c; i++) {
-		int ret = PyList_SetItem(list, i, Py_BuildValue("i", info[i]));
-		if (ret == -1) {
-			return NULL;
-		}
-	}
-	count->integer = c;
-	free(info);
-    return Py_BuildValue("i",status);
-}
-
-/*
- * py_pjsua_acc_find_for_outgoing
- */
-static PyObject *py_pjsua_acc_find_for_outgoing
-(PyObject *pSelf, PyObject *pArgs)
-{    
-	
-	int acc_id;	
-	PyObject * url;
-	pj_str_t str;
-
-    if (!PyArg_ParseTuple(pArgs, "O", &url))
-    {
-        return NULL;
-    }
-	str.ptr = PyString_AsString(url);
-	str.slen = strlen(PyString_AsString(url));
-	
-    acc_id = pjsua_acc_find_for_outgoing(&str);
-	
-    return Py_BuildValue("i", acc_id);
-}
-
-/*
- * py_pjsua_acc_find_for_incoming
- */
-static PyObject *py_pjsua_acc_find_for_incoming
-(PyObject *pSelf, PyObject *pArgs)
-{    	
-	int acc_id;	
-	pjsip_rx_data_Object * obj;
-	pjsip_rx_data * rdata;
-
-    if (!PyArg_ParseTuple(pArgs, "O", &obj))
-    {
-        return NULL;
-    }
-	
-	rdata = obj->rdata;
-    acc_id = pjsua_acc_find_for_incoming(rdata);
-	
-    return Py_BuildValue("i", acc_id);
-}
-
-/*
- * py_pjsua_acc_create_uac_contact
- */
-static PyObject *py_pjsua_acc_create_uac_contact
-(PyObject *pSelf, PyObject *pArgs)
-{    	
-	int status;
-	int acc_id;	
-	pj_pool_Object * p;
-	pj_pool_t * pool;
-	PyObject * strc;
-	pj_str_t contact;
-	PyObject * stru;
-	pj_str_t uri;
-
-    if (!PyArg_ParseTuple(pArgs, "OOiO", &p, &strc, &acc_id, &stru))
-    {
-        return NULL;
-    }
-	
-	pool = p->pool;
-	contact.ptr = PyString_AsString(strc);
-	contact.slen = strlen(PyString_AsString(strc));
-	uri.ptr = PyString_AsString(stru);
-	uri.slen = strlen(PyString_AsString(stru));
-    status = pjsua_acc_create_uac_contact(pool, &contact, acc_id, &uri);
-	strc = PyString_FromStringAndSize(contact.ptr, contact.slen);
-	
-    return Py_BuildValue("i", status);
-}
-
-/*
- * py_pjsua_acc_create_uas_contact
- */
-static PyObject *py_pjsua_acc_create_uas_contact
-(PyObject *pSelf, PyObject *pArgs)
-{    	
-	int status;
-	int acc_id;	
-	pj_pool_Object * p;
-	pj_pool_t * pool;
-	PyObject * strc;
-	pj_str_t contact;
-	pjsip_rx_data_Object * objr;
-	pjsip_rx_data * rdata;
-
-    if (!PyArg_ParseTuple(pArgs, "OOiO", &p, &strc, &acc_id, &objr))
-    {
-        return NULL;
-    }
-	
-	pool = p->pool;
-	contact.ptr = PyString_AsString(strc);
-	contact.slen = strlen(PyString_AsString(strc));
-	rdata = objr->rdata;
-    status = pjsua_acc_create_uas_contact(pool, &contact, acc_id, rdata);
-	strc = PyString_FromStringAndSize(contact.ptr, contact.slen);
-	
-    return Py_BuildValue("i", status);
-}
-
-static char pjsua_acc_config_default_doc[] =
-    "void py_pjsua.acc_config_default (py_pjsua.Acc_Config cfg) "
-    "Call this function to initialize account config with default values.";
-static char pjsua_acc_get_count_doc[] =
-    "int py_pjsua.acc_get_count () "
-    "Get number of current accounts.";
-static char pjsua_acc_is_valid_doc[] =
-    "int py_pjsua.acc_is_valid (int acc_id)  "
-    "Check if the specified account ID is valid.";
-static char pjsua_acc_set_default_doc[] =
-    "int py_pjsua.acc_set_default (int acc_id) "
-    "Set default account to be used when incoming "
-	"and outgoing requests doesn't match any accounts.";
-static char pjsua_acc_get_default_doc[] =
-    "int py_pjsua.acc_get_default () "
-    "Get default account.";
-static char pjsua_acc_add_doc[] =
-    "int py_pjsua.acc_add (py_pjsua.Acc_Config cfg, "
-	"int is_default, py_pjsua.Acc_ID p_acc_id) "
-    "Add a new account to pjsua. PJSUA must have been initialized "
-	"(with pjsua_init()) before calling this function.";
-static char pjsua_acc_add_local_doc[] =
-    "int py_pjsua.acc_add_local (int tid, "
-	"int is_default, py_pjsua.Acc_ID p_acc_id) "
-    "Add a local account. A local account is used to identify "
-	"local endpoint instead of a specific user, and for this reason, "
-	"a transport ID is needed to obtain the local address information.";
-static char pjsua_acc_del_doc[] =
-    "int py_pjsua.acc_del (int acc_id) "
-    "Delete account.";
-static char pjsua_acc_modify_doc[] =
-    "int py_pjsua.acc_modify (int acc_id, py_pjsua.Acc_Config cfg) "
-    "Modify account information.";
-static char pjsua_acc_set_online_status_doc[] =
-    "int py_pjsua.acc_set_online_status (int acc_id, int is_online) "
-    "Modify account's presence status to be advertised "
-	"to remote/presence subscribers.";
-static char pjsua_acc_set_registration_doc[] =
-    "int py_pjsua.acc_set_registration (int acc_id, int renew) "
-    "Update registration or perform unregistration.";
-static char pjsua_acc_get_info_doc[] =
-    "int py_pjsua.acc_get_info (int acc_id, py_pjsua.Acc_Info info) "
-    "Get account information.";
-static char pjsua_enum_accs_doc[] =
-    "int py_pjsua.enum_accs (py_pjsua.Acc_ID ids[], py_pjsua.Integer count) "
-    "Enum accounts all account ids.";
-static char pjsua_acc_enum_info_doc[] =
-    "int py_pjsua.acc_enum_info (py_pjsua.Acc_Info info[], "
-	"py_pjsua.Integer count) "
-    "Enum accounts info.";
-static char pjsua_acc_find_for_outgoing_doc[] =
-    "int py_pjsua.acc_find_for_outgoing (string url) "
-    "This is an internal function to find the most appropriate account "
-	"to used to reach to the specified URL.";
-static char pjsua_acc_find_for_incoming_doc[] =
-    "int py_pjsua.acc_find_for_incoming (pjsip_rx_data_Object rdata) "
-    "This is an internal function to find the most appropriate account "
-	"to be used to handle incoming calls.";
-static char pjsua_acc_create_uac_contact_doc[] =
-    "int py_pjsua.acc_create_uac_contact (pj_pool_Object pool, "
-	"string contact, int acc_id, string uri) "
-    "Create a suitable URI to be put as Contact based on the specified "
-	"target URI for the specified account.";
-static char pjsua_acc_create_uas_contact_doc[] =
-    "int py_pjsua.acc_create_uas_contact (pj_pool_Object pool, "
-	"string contact, int acc_id, pjsip_rx_data_Object rdata) "
-    "Create a suitable URI to be put as Contact based on the information "
-	"in the incoming request.";
-
-/* END OF LIB ACCOUNT */
-
-/* XXX test */
-static PyObject *py_my_parse_by_reference
-(PyObject *pSelf, PyObject *pArgs)
-{    
-    PyObject *obj;
-
-    if (!PyArg_ParseTuple(pArgs, "O", &obj))
-    {
-        return NULL;
-    }
-
-
-    Py_INCREF(Py_None);
-    return Py_None;
-}
-
-/* XXX end-test */
+static char pjsua_get_buddy_count_doc[] =
+    "int py_pjsua.get_buddy_count () "
+    "Get total number of buddies.";
+static char pjsua_buddy_is_valid_doc[] =
+    "int py_pjsua.buddy_is_valid (int buddy_id) "
+    "Check if buddy ID is valid.";
+static char pjsua_enum_buddies_doc[] =
+    "int[] py_pjsua.enum_buddies (int count) "
+    "Enum buddy IDs.";
+static char pjsua_buddy_get_info_doc[] =
+    "py_pjsua.Buddy_Info py_pjsua.buddy_get_info (int buddy_id) "
+    "Get detailed buddy info.";
+static char pjsua_buddy_add_doc[] =
+    "int,int py_pjsua.buddy_add (py_pjsua.Buddy_Config cfg) "
+    "Add new buddy.";
+static char pjsua_buddy_del_doc[] =
+    "int py_pjsua.buddy_del (int buddy_id) "
+    "Delete buddy.";
+static char pjsua_buddy_subscribe_pres_doc[] =
+    "int py_pjsua.buddy_subscribe_pres (int buddy_id, int subscribe) "
+    "Enable/disable buddy's presence monitoring.";
+static char pjsua_pres_dump_doc[] =
+    "void py_pjsua.pres_dump (int verbose) "
+    "Dump presence subscriptions to log file.";
+static char pjsua_im_send_doc[] =
+    "int py_pjsua.im_send (int acc_id, string to, string mime_type, "
+    "string content, py_pjsua.Msg_Data msg_data, int user_data) "
+    "Send instant messaging outside dialog, using the specified account "
+    "for route set and authentication.";
+static char pjsua_im_typing_doc[] =
+    "int py_pjsua.im_typing (int acc_id, string to, int is_typing, "
+    "py_pjsua.Msg_Data msg_data) "
+    "Send typing indication outside dialog.";
+
+/* END OF LIB BUDDY */
+
 
 
@@ -4689,5 +4954,6 @@
 {
     {
-	"my_parse_by_reference", py_my_parse_by_reference, METH_VARARGS, ""
+        "thread_register", py_pjsua_thread_register, METH_VARARGS, 
+         pjsua_thread_register_doc
     },
     {
